SystemOrganization addCategory: #'SWT-Core-Widgets'!
SystemOrganization addCategory: #'SWT-Core-Widgets-Panels'!
SystemOrganization addCategory: #'SWT-Core-Widgets-Events'!
SystemOrganization addCategory: #'SWT-Core-Application'!
SystemOrganization addCategory: #'SWT-Examples'!
SystemOrganization addCategory: #'SWT-Examples-SocialShopping-View'!
SystemOrganization addCategory: #'SWT-Examples-SocialShopping-Model'!

S2SObject subclass: #SWTClientApplication
	instanceVariableNames: 'rootWidget serverSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/3/2006 12:51'!
allJsClasses

	| result |

	result := Set new.

	result addAll: S2SObject jsWithAllClassesToInclude.

	result addAll: SWTWidget jsWithAllClassesToInclude.
	SWTWidget allSubclasses do:[:each |
		result addAll: each jsWithAllClassesToInclude.
	].

	result addAll: SWTServerApplicationProxy jsWithAllClassesToInclude.

	self = SWTClientApplication ifFalse:[
		result addAll: SWTClientApplication jsWithAllClassesToInclude.
	].

	result addAll: self jsWithAllClassesToInclude.

	^ result
! !

!SWTClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/1/2006 19:13'!
applicationName
	^ self name asString! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/3/2006 18:39'!
handMadeJavascriptSource

	| steps |

	steps := self javascriptSteps.

	^ '
<script type="text/javascript">
	document.writeln(''<p>&nbsp;</p><div style="position: relative; left: 15%; top: 15%; width: 70%; background-color: #f6f6ff; border: 2px solid #000033;"><h3>&nbsp;&nbsp;Loading...</h3><center><i><b><font size="-1"><p id="messageW">message</p></font></b></i></center><div style="position: relative; left: 10%; width: 80%; background-color: #ccccff; border: 1px solid #000033;"><div id="barW" style="width:0%; background-color: #333366;">-</div></div><p>&nbsp;</p></div>'');

	// No var, to use delete
	ExpectedLoadSteps = ' , steps asString , ';
	LoadStep = 0;

	// This sintax, to use delete
	setPercentAndMessage = function(message) {
		var percent = Math.min(LoadStep / ExpectedLoadSteps * 100, 100);

		var barW = document.getElementById("barW");
		var messageW = document.getElementById("messageW");

		barW.style.width = percent + "%";
		barW.innerHTML = "<font color=''white''><b>&nbsp;" + Math.round(percent) + "%</b></font>";

		var msg;
		msg = message + " (" + LoadStep + "/" + ExpectedLoadSteps + ")";
		messageW.innerHTML = msg;

		window.status = "Loading: " + Math.round(percent) + "%   - " + msg + "...";
	}

	setPercentAndMessage("");

	// This sintax, to use delete
	doLoadStep = function(name) {
		LoadStep++;

		setPercentAndMessage(name);
				
		if (LoadStep == ExpectedLoadSteps) {
			// cleanup the document
			document.body.innerHTML = '''';
			window.status = "";

			// removes initial objects, no more needed after loading.
			delete LoadStep;
			delete ExpectedLoadSteps;
			delete doLoadStep;
			delete setPercentAndMessage;
		}
	}
</script>

<script type="text/javascript">
	var application = null;

	function fullLoaded() {
		// Do something, all resources (including scripts) where loaded
		application = ' , self jsClassName , '.__new__();

		var iframe = id("CometIFrame");
		if (!!iframe) {
			logError ( "The IFrame with id=CometIFrame is not present" );
			return;
		}

		if (iframe.addEventListener) {
			iframe.addEventListener("load", reconnect, false);
		}
		else if (iframe.attachEvent) {
			iframe.attachEvent("onload", reconnect);
		}
		else {
			iframe.onload = reconnect;
		}

		reconnect();
	}

	function unload() {
		if (application) {
			application.finalize();
		}
	}
</script>
'! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/3/2006 18:54'!
htmlSource: serverApplicationIncludeString

	^ '
<html>
	<head>
		<meta http-equiv="pragma"			content="no-cache">
		<meta http-equiv="cache-control"	content="no-cache">
		<meta http-equiv="expires"			content="1 Jan 1900 00:00:00 GMT">
		<title>' , self applicationName , '</title>

		<style>
' , self htmlStyle withBlanksTrimmed , '
		</style>

		<!!-- ------------------------------------------------------- -->
		<!!-- hand made javascript source -->
' , self handMadeJavascriptSource withBlanksTrimmed , '
		<!!-- ------------------------------------------------------- -->

		<!!-- ------------------------------------------------------- -->
		<!!-- generated javascript source -->
' , self includeJavascriptSource withBlanksTrimmed , '
		<!!-- ------------------------------------------------------- -->

		<!!-- ------------------------------------------------------- -->
		<!!-- server application Include -->
' , serverApplicationIncludeString withBlanksTrimmed , '
		<!!-- ------------------------------------------------------- -->
	</head>

	<body onLoad="fullLoaded()" onUnload="unload()">
<!!--
		<div id="log">
			<div>
				<h1>Log</h1>
			</div>
		</div>
-->
		<iframe id="CometIFrame" style="visibility: hidden; width:0px; height:0px; border: 0px" src="/blank.html"></iframe>
	</body>
</html>
'! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/3/2006 20:15'!
htmlStyle
	^ ''! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/1/2006 20:01'!
includeEmbeddedJavascript
	^ true! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/1/2006 20:01'!
includeJavascriptInSteps
	^ true! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:16'!
includeJavascriptSource

	| stream |

	stream := String new writeStream.

	self includeJavascriptInSteps ifTrue:[
		| classes |

		stream nextPutAll: ('<!!-- Include JavaScript in {1} steps (__pre__, classes and  __post__) -->' format: {self javascriptSteps}); cr.

		stream nextPutAll: '<!!-- First the pre  -->'; cr.
		self includeJavascriptSource: '__pre__' on: stream.

		stream nextPutAll: '<!!-- Then the classes  -->'; cr.
		classes := self allJsClasses asSortedCollection:[:x :y | x jsGoesBefore: y].
		classes do:[:each |
			self includeJavascriptSource: each jsClassName on: stream.
		].

		stream nextPutAll: '<!!-- Finally the post  -->'; cr.
		self includeJavascriptSource: '__post__' on: stream.
	]
	ifFalse: [
		stream nextPutAll: '<!!-- Include all JavaScript code in a shot -->'; cr.
		self includeJavascriptSource: '__all__' on: stream.
	].

	^ stream contents.
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:50'!
includeJavascriptSource: sourceNameString on: stream

	self includeEmbeddedJavascript ifTrue: [
		stream nextPutAll: '<!!-- Embedded: "' , sourceNameString , '" -->'; cr.
		stream nextPutAll: '<script type=''text/javascript''>'; cr.
		stream nextPutAll: (self updateLoadProgressIndicator: sourceNameString).
		stream nextPutAll: (self sourceForClass: sourceNameString) withoutTrailingBlanks; cr.
		stream nextPutAll: '</script>'; cr; cr.
	]
	ifFalse: [
		stream nextPutAll: '<script type=''text/javascript'' src=''/JavascriptSource/' , self name , '/' , sourceNameString , '.js''></script>'; cr
	]
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:57'!
isValidClassName: sourceName

	(#('__all__' '__pre__' '__post__') includes: sourceName)
		ifTrue:[^ true].
		
	^ self allJsClasses anySatisfy:[:each | each jsClassName = sourceName]! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:12'!
javascriptSteps
	^ self includeJavascriptInSteps
					ifTrue: [self allJsClasses size + (2 "__pree__ and __post__")]
					ifFalse:[1].
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:19'!
sourceForClass: sourceName
	^ self sourceForClass: sourceName selector: nil! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:19'!
sourceForClass: sourceName selector: selectorName

	| translator |

	translator := S2STranslator new.
"
	translator showSmalltalkSource: true.
	translator showMethodComments: true.
"
	
	(sourceName = '__all__')
		ifTrue: [ ^ translator allJsSourceFor: self allJsClasses ].

	(sourceName = '__pre__')
		ifTrue:[ ^ translator preJsSourceFor: self allJsClasses ].
				
	(sourceName = '__post__')
		ifTrue:[ ^ translator postJsSourceFor: self allJsClasses ].
				
	selectorName isNil
		ifTrue:[ ^ translator sourceForClassJsNamed: sourceName ].
	
	^ translator sourceForClassJsNamed: sourceName selector: selectorName.
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 20:07'!
updateLoadProgressIndicator: sourceName

	^ '/* Try to update the load progress indicator */
try { doLoadStep(''' , sourceName , '''); } catch(err) { /* just ignore any error */ }
'! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 20:46'!
connectionId
	^ self jsLiteral: 'ConnectionId'! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 9/3/2006 16:25'!
createRootWidget
	"create the root widgets for the receiver"
	^ SWTRootPanel default! !

!SWTClientApplication methodsFor: 'running' stamp: 'dgd 9/3/2006 16:18'!
finalize
	"The application is being finalized, please cleanup your garbage"

	self rootWidget unload.
! !

!SWTClientApplication methodsFor: 'initialization' stamp: 'dgd 9/3/2006 16:24'!
initialize
	"Initialize the receiver"

	super initialize.

	serverSide := SWTServerApplicationProxy clientApplication: self.
"
	self onLoad.
"
	self initializeWidgets.
! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 9/3/2006 16:26'!
initializeWidgets
	"Initialize the receiver's widgets"

	self subclassResponsibility.! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 8/31/2006 19:27'!
rootWidget
	"Answer the receiver's root widget"

	rootWidget isNil ifTrue:[rootWidget := self createRootWidget].

	^ rootWidget! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 8/31/2006 20:25'!
serverSide
	"Answer the receiver's server side counterpart"

	^ serverSide! !

SWTClientApplication subclass: #SWTExampleClientApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTExampleClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/4/2006 12:34'!
applicationName
	^ 'Example Application'! !

!SWTExampleClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/3/2006 20:15'!
htmlStyle
	^ '
html {
	/* height: 100%; */
	/* border: 0px; */
}

body {
	/* margin: 0px; */
	/* height: 100%; */
	background-color: #FFFFFF;
	cursor: default;
}
'
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/3/2006 16:42'!
addNewEditInPlaceText

	| root |

	root := self rootWidget.

	root addWidget: (SWTEditInPlaceText contents: 'Edit-in-place text (with background color), click on me to edit').
	root lastWidget
			width: 100 percent;
			backgroundColor: S2SColor yellow muchLighter.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/1/2006 19:26'!
createButtons

	| root button |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 2 contents: 'Buttons').
	root addWidget: (SWTButton caption: 'inspect event' onClick: [:event | event inspect]).
	root addWidget: (SWTButton caption: 'inspect root panel' onClick: [:event | root inspect]).

	root addWidget: (button := SWTButton caption: 'button with several event handlers').

	button onClick: [:event | event inspect].
	button onClick: [:event | self inform: '2st handler: ' , event asString].
	button onClick: [:event | self inform: '3rd handler: ' , event asString].

	button 
			color: S2SColor blue;
			backgroundColor: S2SColor blue muchLighter.

	button onFocus: [:event |
		event source
			color: S2SColor red;
			backgroundColor: S2SColor red muchLighter
	].

	button onBlur: [:event |
		event source
			color: S2SColor blue;
			backgroundColor: S2SColor blue muchLighter
	].

! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/3/2006 16:30'!
createEditableTexts

	| root |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 2 contents: 'Edit-In-Place texts').

	root addWidget: (SWTEditInPlaceText contents: 'One edit-in-place text, click on me to edit').
	root addBreak.

	root addWidget: (SWTEditInPlaceText contents: 'Another edit-in-place text (with background color), double click on me to edit').
	root lastWidget
			editOnDblClick;
			backgroundColor: S2SColor blue muchLighter.
	root addBreak.

	root addWidget: (SWTEditInPlaceText contents: 'Just another edit-in-place text (with background color), move mouse over me to edit').
	root lastWidget
			editOnMouseOver;
			backgroundColor: S2SColor red muchLighter.
	root addBreak.

	root addWidget: (SWTEditInPlaceText contents: 'And just another edit-in-place text (with background color), move mouse over me to edit').
	root lastWidget
			editOnMouseOver;
			backgroundColor: S2SColor green muchLighter.
	root addBreak.

	root addWidget: (SWTButton caption: 'add a new edit-in-place text' onClick: [:event | self addNewEditInPlaceText]).
	root lastWidget backgroundColor: S2SColor yellow muchLighter.
	root addBreak.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/3/2006 16:31'!
createHeaders

	| root |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 1 contents: 'header level 1 (double-click on me)').

	root lastWidget color: S2SColor black.
	root lastWidget onDblClick: [:event |
		| newColor |

		newColor := (event source color = S2SColor black)
								ifTrue: [S2SColor red]
								ifFalse: [S2SColor black].

		event source color: newColor.
	].

	root addWidget: (SWTHeader level: 2 contents: 'header level 2 (move mouse over me)').
	root lastWidget
		onMouseOver: [:event | event source backgroundColor: S2SColor green];
		onMouseOut: [:event | event source backgroundColor: S2SColor white].

	root addWidget: (SWTHeader level: 3 contents: 'header level 3').
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/3/2006 20:20'!
createMoreInterestingWidgets

	| root |

	root := self rootWidget.

	root addHorizontalRule.

	root addWidget: (SWTHeader level: 2 contents: 'More interesting widgets').

	root addWidget: (SWTHeader level: 3 contents: 'Server-Side message sending (see Squeak transcript)').
	root addWidget: (SWTButton caption: 'self serverSide foo' onClick: [:event | self serverSide foo]).
	root addWidget: (SWTButton caption: 'self serverSide bar: 1' onClick: [:event | self serverSide bar: 1]).
	root addWidget: (SWTButton caption: 'self serverSide bar: ''a''' onClick: [:event | self serverSide bar: 'a']).

	root addWidget: (SWTHeader level: 3 contents: 'Server-Side message sending with impact on the client side').
	root addWidget: (SWTButton caption: 'self serverSide ping' onClick: [:event | self serverSide ping]).

	root addHorizontalRule.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/3/2006 16:35'!
createSimpleTexts

	| root |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 2 contents: 'Simple texts').

	root addWidget: (SWTText contents: 'some plain text.').

	root addWidget: (SWTText contents: 'text in red.').
	root lastWidget
			color: S2SColor red.

	root addWidget: (SWTText contents: 'text in blue/green.').
	root lastWidget
			color: S2SColor blue;
			backgroundColor: S2SColor green.

	root addBreak.
! !

!SWTExampleClientApplication methodsFor: 'configuration' stamp: 'dgd 9/5/2006 20:05'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root addWidget: (SWTText contents: 'press CTRL + SHIFT + ALT + Double-Click, on the document, to inspect the application object').
	root onDblClick:[:event |
		(event ctrlKey and:[event shiftKey]  and:[event altKey]) ifTrue:[
			self inspect.
		]
	].
	root addBreak.

	self createSimpleTexts.
	self createHeaders.
	self createButtons.
	self createEditableTexts.

	self createMoreInterestingWidgets.
! !

!SWTExampleClientApplication methodsFor: 'tests' stamp: 'dgd 9/3/2006 20:21'!
pong
	^ self inform: 'pong!!'! !

SWTClientApplication subclass: #SWTPingPongClientApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTPingPongClientApplication class methodsFor: 'as yet unclassified' stamp: 'dgd 9/5/2006 20:04'!
applicationName
	^ 'Ping Pong'! !

!SWTPingPongClientApplication methodsFor: 'configuration' stamp: 'dgd 9/5/2006 20:08'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root addWidget: (SWTHeader level: 2 contents: self class applicationName).

	root addWidget: (SWTButton caption: 'server ping' onClick: [:event | self serverSide ping]).
! !

!SWTPingPongClientApplication methodsFor: 'ping/pong' stamp: 'dgd 9/5/2006 20:06'!
pong
	^ self inform: 'pong!!'! !

SWTClientApplication subclass: #SWTSocialShoppingClientApplication
	instanceVariableNames: 'usersListWidget chatMessagesWidget lastUserName inventoryPanel cartPanel cartTotalPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-View'!

!SWTSocialShoppingClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/5/2006 22:35'!
applicationName
	^ 'Social Shopping (Demo)'! !

!SWTSocialShoppingClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/4/2006 19:00'!
htmlStyle
	^ '
html {
	/*height: 100%;*/
	border: 0px;
}

body {
	margin: 0px;
	/*height: 100%;*/
	background-color: #FFFFFF;
	cursor: default;
}
'
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 18:09'!
baseColor

	^ S2SColor blue! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 19:58'!
buyProductId: anInteger
	self serverSide buyProductId: anInteger! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 20:49'!
cartPanel

	| panel totalPanel |

	panel := SWTColumnPanel new.

	panel
"		border: 1;"
		width: 100 percent;
		height: 100 percent.

	panel addWidget: (SWTText contents: 'carrito de compras:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.

	panel addWidget: (cartPanel := SWTPanel new).
	panel lastWidget
		overflow: 'auto';
		border: 1;
		width: 100 percent;
		height: 100 percent;
		borderColor: self baseColor muchDarker;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

	totalPanel := SWTRowPanel new.
	totalPanel
		backgroundColor: self baseColor muchLighter;
		"border: 1;"
		cellPadding: 5;
		width: 100 percent.
	totalPanel addWidget: (SWTText contents: 'total compra:').
	totalPanel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.

	totalPanel addWidget: (cartTotalPanel := SWTPanel new).
	totalPanel lastWidget
		border: 1;
		width: 100 percent;
		height: 100 percent;
		borderColor: self baseColor muchDarker;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

	panel addWidget: totalPanel.
	panel cellsHeight: {1 percent. 98 percent. 1 percent.}.

	^ panel.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 18:13'!
chatPanel

	| panel userListPanel |

	panel := SWTColumnPanel new.
	panel
"		border: 1;"
		cellPadding: 0;
		height: 100 percent;
		width: 100 percent.

"	panel addWidget: (SWTText contents: 'online users:')."
	panel addWidget: (SWTText contents: 'compradores:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.
	panel addWidget: (userListPanel := SWTPanel new).
	panel lastWidget
		overflow: 'auto';
		fontSize: 'small';
		border: 1;
		borderColor: self baseColor muchDarker;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.
	userListPanel addWidget: (usersListWidget := SWTText contents: '').

	panel addWidget: (SWTText contents: 'chat:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.
	panel addWidget: (chatMessagesWidget := SWTPanel new).
	panel lastWidget
		overflow: 'scroll';
		fontSize: 'small';
		border: 1;
		borderColor: self baseColor muchDarker;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

"	panel addWidget: (SWTText contents: 'your chat message:')."
	panel addWidget: (SWTText contents: 'su mensaje:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.
	panel addWidget: (SWTInputText contents: '').
	panel lastWidget
		border: 1;
		borderColor: self baseColor muchDarker;
		width: 100 percent.

	panel lastWidget
		onChange: [:event | self sendChatMessage: event source ];
		onKeyPress: [:event |
			(event keyCode = 13) ifTrue:[
"					(event ctrlKey or:[event shiftKey]) ifFalse:[]."
					self sendChatMessage: event source.
				]
		].

	panel cellsHeight: {1 percent. 30 percent. 1 percent. 66 percent. 1 percent. 1 percent}.

	^ panel.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 15:08'!
helpPanel

	| text panel |

"
	text := SWTText contents: 'This is a proof-of-concept for a new type of online store: Social-Shopping.  Shopping is a social activity and most of the online stores ignore this fact.  Social-Shopping allows more than one shooper to interact into a single buying process.  The cart can be handled simultaneously by every authorized shooper.  Social-Shopping also considers the role of the seller, that can offer help to the shoppers.'.
"
	text := SWTText contents: 'Esto es una demostracin de <b>Social Shopping</b> (Compra Social).<br><br>Comprar es una actividad social, y la mayora de las tiendas online ignoran ese hecho.  <b>Social Shopping</b> permite interactuar, a ms de un comprador, en el mismo proceso de compra.  El carrito de la compra puede ser manipulado, simultneamente, por cada uno de los compradores autorizados y los cambios son visibles, en tiempo real, por los otros compradores. <b>Social Shopping</b> tambin considera el rol del vendedor, que puede ofrecer ayuda (en tiempo real) en la compra.  Todos los actores, del proceso de la compra, pueden comunicarse entre si usando el chat provisto.'.

	text fontSize: 'x-small'.

	panel := SWTRowPanel withAllWidgets: { SWTImage src: 'help.png'. text }.
	panel
		cellPadding: 10.

	^ panel! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/5/2006 19:28'!
initializeWidgets
	"Initialize the receiver's widgets"

	| column |

	column := SWTColumnPanel withAllWidgets: { self titlePanel. self mainPanel. self helpPanel. }.

	column
		cellsHeight: {1 percent. 98 percent. 1 percent};
		cellsVAlign: {'bottom'. 'top'. 'top'};
		width: 100 percent;
		height: 100 percent.

	self rootWidget addWidget: column.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 19:27'!
inventoryPanel

	| panel |

	panel := SWTColumnPanel new.

	panel
"		border: 1;"
		width: 100 percent;
		height: 100 percent.

	panel addWidget: (SWTText contents: 'inventario de productos:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.

	panel addWidget: (inventoryPanel := SWTPanel new).
	panel lastWidget
		overflow: 'auto';
		border: 1;
		width: 100 percent;
		height: 100 percent;
		borderColor: self baseColor muchDarker;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

	panel cellsHeight: {1 percent. 99 percent}.

	^ panel! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 20:19'!
mainPanel

	| panel |

	panel := SWTRowPanel withAllWidgets: { self chatPanel. self inventoryPanel. self cartPanel }.

	panel
		cellPadding: 10;
		width: 100 percent;
		height: 100 percent;
		cellsWidth: {25 percent. 50 percent. 25 percent};
		cellsBackgroundColor: {self baseColor muchLighter. self baseColor muchLighter muchLighter. self baseColor muchLighter muchLighter }.

	^ panel.
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 20:28'!
notBuyProductId: anInteger
	self serverSide notBuyProductId: anInteger! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 20:38'!
receiveCart: aCollection
	| first total |

	cartPanel clearWidgets.

	total := 0.

	first := true.
	aCollection inlineDo:[:dict |
		| t p c id panel  |

		t := dict first.
"		d := dict second."
		p := dict third.
		c := dict fourth.
"		i := dict fifth."
		id := dict sixth.

		panel := SWTRowPanel new.
		panel
			cellPadding: 1;
			width: 100 percent.

		panel addWidget: (SWTButton caption: '-' onClick:[:event | self notBuyProductId: event source model ]).
		panel lastWidget model: id.
		panel addWidget: (SWTText contents: c asString).
		panel addWidget: (SWTText contents: t asString).
		panel addWidget: (SWTText contents: '&euro;' , (p * c) asString).

		panel cellsWidth: {10 percent. 10 percent. 70 percent. 10 percent}.

		first
			ifTrue:[ first := false ]
			ifFalse:[ cartPanel addHorizontalRule ].

		cartPanel addWidget: panel.

		total := total + (p * c).
	].

	cartTotalPanel clearWidgets.
	cartTotalPanel addWidget: (SWTText contents: '&euro; ' , total asString).
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 9/6/2006 12:51'!
receiveChatMessage: aString from: userNameString

	| userName |

	userName := userNameString.

	userName = self userName
		ifTrue:[userName := 'me'].

	(lastUserName = userName)
		ifTrue:[userName := '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' first: lastUserName size * 6]
		ifFalse:[lastUserName := userName].

	chatMessagesWidget 
		addWidget: (SWTText contents: '<tt><b>' , userName , '</b></tt> ' , aString);
		addBreak;
		goBottom.
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 20:21'!
receiveInventory: aCollection

	| first |

	inventoryPanel clearWidgets.

	first := true.
	aCollection inlineDo:[:dict |
		| t d p c i id panel detailsPanel |

		t := dict first.
		d := dict second.
		p := dict third.
		c := dict fourth.
		i := dict fifth.
		id := dict sixth.

		panel := SWTRowPanel new.
		panel
			cellPadding: 5.

		panel addWidget: (SWTImage src: i).

		detailsPanel := SWTColumnPanel new.
		detailsPanel addWidget: (SWTText contents: t asString).
		detailsPanel lastWidget
			fontSize: 'large';
			bold.
		detailsPanel addWidget: (SWTText contents: d asString).
		detailsPanel lastWidget
			fontSize: 'small';
			italic.
		detailsPanel addWidget: (SWTText contents: '<b>precio:</b> &euro;' , p asString , '.  <b>disponibles:</b> ' , c asString , ' unidades').
		detailsPanel addWidget: (SWTButton caption: 'Agregar al Carrito' onClick:[:event | self buyProductId: event source model ]).
		detailsPanel lastWidget model: id.

		panel addWidget: detailsPanel.

		first
			ifTrue:[ first := false ]
			ifFalse:[ inventoryPanel addHorizontalRule ].

		inventoryPanel addWidget: panel.
	].
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 9/5/2006 23:02'!
receiveUsersList: aCollection

	| userList |

	userList := S2SStringExtension new writeStream.

"	userList nextPutAll: '<ul>'."
	(S2SArrayExtension withAll: aCollection)
		reject:[:each | each = self userName]
		thenDo:[:each |
			userList nextPutAll: '<li>'.
			userList nextPutAll: each asString.
		].

"	userList nextPutAll: '</ul>'."

	usersListWidget contents: userList contents.! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 9/5/2006 20:48'!
sendChatMessage: aInputTextWidget
	| msg |

	msg := aInputTextWidget contents.
	aInputTextWidget contents: ''.

	msg isEmpty
		ifTrue:[^ self].

	self serverSide
				receiveChatMessage: msg
				from: self userName.

	aInputTextWidget focus.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/5/2006 20:28'!
titlePanel

	| titlePanel legendsPanel |

	titlePanel := SWTRowPanel new.
	titlePanel cellPadding: 5.
	titlePanel addWidget: (SWTImage src: 'minicart.png').

	legendsPanel := SWTColumnPanel new.

	legendsPanel addWidget: (SWTText contents: self class applicationName).
	legendsPanel lastWidget
		fontSize: 'x-large';
		bold.

"	legendsPanel addWidget: (SWTText contents: 'e-commerce for the web 2.0 age')."
	legendsPanel addWidget: (SWTText contents: 'comercio electrnico para la era web 2.0').
	legendsPanel lastWidget
		fontSize: 'large';
		italic.
	titlePanel addWidget: legendsPanel.

	^ titlePanel
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 9/5/2006 20:47'!
userName
	^ '#' , self connectionId asString.
! !

S2SObject subclass: #SWTEvent
	instanceVariableNames: 'source domEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTEvent subclass: #SWTBlurEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

!SWTEvent class methodsFor: 'instance creation' stamp: 'dgd 8/9/2006 12:26'!
source: aWidget domEvent: aDomEvent
	^ self new initializeSource: aWidget domEvent: aDomEvent! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 9/5/2006 10:33'!
altKey
	^ domEvent jsGet: #altKey! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 9/5/2006 10:33'!
ctrlKey
	^ domEvent jsGet: #ctrlKey! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:05'!
domEvent
	"Answer the receiver's domEvent."
	^ domEvent! !

!SWTEvent methodsFor: 'private' stamp: 'dgd 8/9/2006 12:30'!
getEvent: anEvent
	"PRIVATE - get the dom event considering the browser differences"

	^ self jsLiteral: 'anEvent ? anEvent : window.event'.
! !

!SWTEvent methodsFor: 'initialization' stamp: 'dgd 8/9/2006 12:29'!
initializeSource: aWidget domEvent: aDomEventOrNil
	"Initialize the receiver's source"
	source := aWidget.
	domEvent := self getEvent: aDomEventOrNil.
! !

!SWTEvent methodsFor: 'printing' stamp: 'dgd 8/10/2006 18:54'!
printOn: aStream
	super printOn: aStream.
"
	aStream nextPutAll: 'a '.
	aStream nextPutAll: self className.
"
	aStream nextPutAll: ' source=('.
	aStream print: source.
	aStream nextPutAll: ')'.
"
	aStream nextPutAll: ', domEvent:'.
	aStream print: domEvent.
"! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 9/5/2006 10:33'!
shiftKey
	^ domEvent jsGet: #shiftKey! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 8/9/2006 12:08'!
source
	"Answer the receiver's source. It means the widget thet generated the event."
	^ source! !

SWTEvent subclass: #SWTFocusEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTEvent subclass: #SWTMouseEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTMouseEvent subclass: #SWTClickEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTMouseEvent subclass: #SWTDblClickEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTMouseEvent subclass: #SWTMouseOutEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTMouseEvent subclass: #SWTMouseOverEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTEvent subclass: #SWTTextEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTTextEvent subclass: #SWTChangeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

SWTTextEvent subclass: #SWTKeyPressEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Events'!

!SWTKeyPressEvent methodsFor: 'accessing' stamp: 'dgd 9/5/2006 10:33'!
keyCode
	^ domEvent jsGet: #keyCode! !

S2SObject subclass: #SWTServerApplicationProxy
	instanceVariableNames: 'clientApplication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTServerApplicationProxy class methodsFor: 'instance creation' stamp: 'dgd 9/3/2006 13:00'!
clientApplication: aClientApplication
	^ self new initializeClientApplication: aClientApplication! !

!SWTServerApplicationProxy methodsFor: 'initialization' stamp: 'dgd 9/3/2006 13:00'!
initializeClientApplication: aClientApplication
	"Initialize the receiver's client application"

	clientApplication := aClientApplication! !

S2SObject subclass: #SWTWidget
	instanceVariableNames: 'parent model color backgroundColor dom onClick onDblClick onMouseOver onMouseOut width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTWidget subclass: #SWTBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTBreak methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:40'!
createDom

	^ self domCreateElement: 'br'
! !

SWTWidget subclass: #SWTFocusWidget
	instanceVariableNames: 'onBlur onFocus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTFocusWidget subclass: #SWTButton
	instanceVariableNames: 'caption'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTButton class methodsFor: 'instance creation' stamp: 'dgd 8/9/2006 11:16'!
caption: aString
	"Answer a new instance of the receiver with the given caption"
	^ self new initializeCaption: aString! !

!SWTButton class methodsFor: 'instance creation' stamp: 'dgd 8/9/2006 11:39'!
caption: aString onClick: aBlock
	"Answer a new instance of the receiver with the given caption"
	^ (self caption: aString)
			onClick: aBlock;
			yourself! !

!SWTButton methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:40'!
createDom

	| button |

	button := self domCreateElement: 'button'.
	button jsSet: #innerHTML to: caption.

	^ button
! !

!SWTButton methodsFor: 'initialization' stamp: 'dgd 8/9/2006 11:17'!
initializeCaption: aString
	"Initialize the receiver's caption"

	caption := aString.
! !

!SWTFocusWidget methodsFor: 'actions' stamp: 'dgd 9/5/2006 11:46'!
focus
	self dom focus! !

!SWTFocusWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 18:54'!
onBlur: aBlock
	"registers a block, to evaluate, when onBlur event occurs"

	"is very first handler?"
	onBlur isNil ifTrue: [
		| handler |

		onBlur := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |
					event := SWTBlurEvent source: self domEvent: domEvent.
					onBlur do: [:each | each value: event].
				].

		self dom jsSet: #onblur to: handler.
	].

	onBlur add: aBlock.
! !

!SWTFocusWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 18:54'!
onFocus: aBlock
	"registers a block, to evaluate, when onFocus event occurs"

	"is very first handler?"
	onFocus isNil ifTrue: [
		| handler |

		onFocus := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |
					event := SWTFocusEvent source: self domEvent: domEvent.
					onFocus do: [:each | each value: event].
				].

		self dom jsSet: #onfocus to: handler.
	].

	onFocus add: aBlock.
! !

!SWTFocusWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 18:13'!
unload

	| myDom |

	myDom := self dom.
	myDom jsSet: #onfocus to: nil.
	myDom jsSet: #onblur to: nil.

	super unload.
! !

SWTFocusWidget subclass: #SWTInputText
	instanceVariableNames: 'contents onChange onKeyPress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTInputText class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 20:55'!
contents: aString
	^ self new initializeContents: aString! !

!SWTInputText class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 21:00'!
contents: aString onChange: aBlock
	^ (self contents: aString)
			onChange: aBlock;
			yourself! !

!SWTInputText methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:03'!
contents
	"Answer the receiver's contents"
	^ contents! !

!SWTInputText methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:17'!
contents: aString
	"Answer the receiver's contents"
	contents := aString.

	self dom jsSet: #value to: contents.! !

!SWTInputText methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 20:55'!
createDom

	| input |

	input := self domCreateElement: 'input'.
	input jsSet: #type to: 'text'.
	input jsSet: #value to: contents.
"
	input jsStyleSet: #width to: self width.
	input jsStyleSet: #height to: self height.

	input jsStyleSet: #borderWidth to: 2.
	input jsStyleSet: #borderStyle to: 'solid'.
	backgroundColor isNil inlineIfFalse:[
		input jsStyleSet: #backgroundColor to: backgroundColor asColorString.
		input jsStyleSet: #borderColor to: backgroundColor muchDarker asColorString.
	].
"
	^ input
! !

!SWTInputText methodsFor: 'initialization' stamp: 'dgd 9/4/2006 20:56'!
initializeContents: aString
	contents := aString.! !

!SWTInputText methodsFor: 'events' stamp: 'dgd 9/5/2006 11:30'!
onChange: aBlock 
	"registers a block, to evaluate, when onChange event occurs"

	"is very first handler?"
	onChange isNil ifTrue: [
		| handler |

		onChange := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |

					event := SWTChangeEvent source: self domEvent: domEvent.

					contents := self dom jsGet: #value.

					onChange do: [:each | each value: event].

					true
				].

		self dom jsSet: #onchange to: handler.
	].

	onChange add: aBlock.
! !

!SWTInputText methodsFor: 'events' stamp: 'dgd 9/5/2006 11:39'!
onKeyPress: aBlock 
	"registers a block, to evaluate, when onKeyPress event occurs"

	"is very first handler?"
	onKeyPress isNil ifTrue: [
		| handler |

		onKeyPress := OrderedCollection new.

		handler :=  [:domEvent | 
					| event returnValue |

					event := SWTKeyPressEvent source: self domEvent: domEvent.

					contents := self dom jsGet: #value.

					returnValue := true.
					onKeyPress do: [:each | (each value: event) == false ifTrue:[returnValue := false]].

					returnValue
				].

		self dom jsSet: #onkeypress to: handler.
	].

	onKeyPress add: aBlock.
! !

SWTWidget subclass: #SWTHorizontalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTHorizontalRule methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:41'!
createDom

	^ self domCreateElement: 'hr'! !

SWTWidget subclass: #SWTImage
	instanceVariableNames: 'src align'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTImage class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 13:45'!
src: aString
	"Answer a new instace of the receiver with the given src"
	^ self new initializeSrc: aString! !

!SWTImage methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:57'!
align: aString

	align := aString.

	self dom jsSet: #align to: align.
! !

!SWTImage methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 13:57'!
createDom

	| img |

	img := self domCreateElement: 'img'.

	img jsSet: #src to: self resourcesDirectory , src.

	^ img! !

!SWTImage methodsFor: 'initialization' stamp: 'dgd 9/4/2006 13:45'!
initializeSrc: aString
	"Initialize the receiver's src"
	src := aString! !

SWTWidget subclass: #SWTPanel
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

SWTPanel subclass: #SWTCellPanel
	instanceVariableNames: 'innerDom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTCellPanel class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 18:11'!
withAllWidgets: widgetsCollection heights: heightsCollection
	^ (self withAllWidgets: widgetsCollection) cellsHeight: heightsCollection! !

!SWTCellPanel class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 18:12'!
withAllWidgets: widgetsCollection widths: widthsCollection
	^ (self withAllWidgets: widgetsCollection) cellsWidth: widthsCollection! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
border: aNumberOrString

	self dom
		jsSet: #border
		to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
cellPadding: aNumberOrString

	self dom
		jsSet: #cellPadding
		to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
cellSpacing: aNumberOrString

	self dom
		jsSet: #cellSpacing
		to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'private' stamp: 'dgd 9/4/2006 18:30'!
cells
	^ self subclassResponsibility! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:59'!
cellsBackgroundColor: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #backgroundColor to: each asColorString.
		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
cellsHeight: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #height to: each.
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:48'!
cellsVAlign: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #vAlign to: each.
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:12'!
cellsWidth: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #width to: each.
	].
! !

!SWTCellPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:08'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	super initializeDom.

	self cellPadding: 0.
	self cellSpacing: 0.
! !

!SWTCellPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:25'!
innerDom

	"force dom creation"
	self dom.

	^ innerDom! !

!SWTCellPanel methodsFor: 'private' stamp: 'dgd 9/4/2006 18:33'!
with: aCollection cellsDo: aBlock
	"Evaluate the given block with a pair of objects. The pair is composed of a cell and the corresponding element in the given collection."

	| cells |

	cells := self cells.

	1
		to: (cells size min: aCollection size)
		do:[:index |
			aBlock value: (cells at: index) value: (aCollection at: index)
		].
! !

SWTCellPanel subclass: #SWTColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTColumnPanel methodsFor: 'private' stamp: 'dgd 9/4/2006 18:38'!
cells

	| rows result innerD |

	result := OrderedCollection new.

	innerD := self innerDom.
	rows := self jsLiteral: 'innerD.getElementsByTagName(''tr'')'.

	rows inlineDo:[:each |
		((each jsGet: #parentNode) == innerD) inlineIfTrue:[
			result add: (each jsGet: #firstChild)
		]
	].

	^ result.
! !

!SWTColumnPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:26'!
createDom

	| table tbody |

	table := self domCreateElement: 'table'.

	tbody := self domCreateElement: 'tbody'.
	self jsLiteral: 'table.appendChild(tbody)'.

	innerDom := tbody.

	^ table.! !

!SWTColumnPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 17:55'!
wrapDom: aDom

	| wrapped td tr |

	wrapped := super wrapDom: aDom.

	td := self domCreateElement: 'td'.
	self jsLiteral: 'td.appendChild(wrapped)'.

	tr := self domCreateElement: 'tr'.
	self jsLiteral: 'tr.appendChild(td)'.

	^ tr.
! !

SWTCellPanel subclass: #SWTRowPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTRowPanel methodsFor: 'private' stamp: 'dgd 9/4/2006 18:38'!
cells

	| cells result innerD |

	result := OrderedCollection new.

	innerD := self innerDom.
	cells := self jsLiteral: 'innerD.getElementsByTagName(''td'')'.

	cells inlineDo:[:each |
		((each jsGet: #parentNode) == innerD) inlineIfTrue:[
			result add: each.
		].
	].

	^ result.
! !

!SWTRowPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:23'!
createDom

	| table tbody tr |

	table := self domCreateElement: 'table'.

	tbody := self domCreateElement: 'tbody'.
	self jsLiteral: 'table.appendChild(tbody)'.

	tr := self domCreateElement: 'tr'.
	self jsLiteral: 'tbody.appendChild(tr)'.

	innerDom := tr.

	^ table.! !

!SWTRowPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:15'!
wrapDom: aDom

	| wrapped td |

	wrapped := super wrapDom: aDom.

	td := self domCreateElement: 'td'.
	self jsLiteral: 'td.appendChild(wrapped)'.

	^ td.
! !

!SWTPanel class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 15:46'!
withAllWidgets: aCollection
	^ self new addAllWidgets: aCollection; yourself! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:45'!
addAllWidgets: aCollection
	aCollection do:[:each | self addWidget: each].! !

!SWTPanel methodsFor: 'utilities' stamp: 'dgd 8/11/2006 13:54'!
addBreak
	self addWidget: SWTBreak new.! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 17:56'!
addDom: aDom
	"add, to the receiver's dom counterpart, the given dom element"

	| innerDom |

	innerDom := self innerDom.

	self jsLiteral: 'innerDom.appendChild(aDom)'.
! !

!SWTPanel methodsFor: 'utilities' stamp: 'dgd 8/11/2006 13:53'!
addHorizontalRule
	self addWidget: SWTHorizontalRule new.! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 16:45'!
addWidget: childWidget

	| childWidgetDom |

	childWidgetDom := self wrapDom: childWidget dom.

	children add: {childWidget. childWidgetDom}.
	childWidget parent: self.

	self addDom: childWidgetDom.

	^ childWidget.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/6/2006 14:22'!
clearWidgets

	[self widgets notEmpty]
		whileTrue:[ self removeWidget: self widgets removeLast ].
! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/5/2006 15:04'!
createDom

	| div |

	div := self domCreateElement: 'div'.

	^ div.! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 16:47'!
enable: aBoolean
	"change the receiver's enable status"

	super enable: aBoolean.
"
	self jsLiteral: 'self.dom().disabled = !!(aBoolean)'.
"
	children do: [:each | each first enable: aBoolean]
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/5/2006 15:11'!
goBottom

	| myDom |
	myDom := self dom.
	myDom jsSet: #scrollTop to: (myDom jsGet: #scrollHeight).
! !

!SWTPanel methodsFor: 'initialization' stamp: 'dgd 9/3/2006 15:49'!
initialize
	"Initialize the receiver"
	super initialize.

	children := OrderedCollection new.
! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 17:46'!
innerDom
	^ self dom! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 16:47'!
lastWidget

	^ children last first! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/5/2006 15:09'!
overflow: aString
	self dom jsStyleSet: #overflow to: aString! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 17:57'!
removeDom: aDom
	"remove, from the receiver's dom counterpart, the given dom element"

	| innerDom |

	innerDom := self innerDom.

	self jsLiteral: 'innerDom.removeChild(aDom)'.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 16:55'!
removeWidget: aWidget

	| widgetDomPair |

	widgetDomPair := children detect:[:each | each first == aWidget].

	self removeDom: widgetDomPair second.

	widgetDomPair first parent: nil.
	children remove: widgetDomPair.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:35'!
textAlign: aString
	self dom jsStyleSet: #textAlign to: aString! !

!SWTPanel methodsFor: 'events' stamp: 'dgd 9/4/2006 16:49'!
unload

	[children notEmpty]
		inlineWhileTrue:[children last first unload].

	super unload.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 16:49'!
widgets
	"Answer the receiver's children collection"

	^ children collect:[:each | each first] "asReadOnlyCollection."
! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 16:44'!
wrapDom: aDom
	^ aDom! !

SWTPanel subclass: #SWTRootPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTRootPanel class methodsFor: 'instance creation' stamp: 'dgd 8/7/2006 13:13'!
default
	"Singleton accessing"
	
	^ self jsLiteral: 'SWT.RootPanel'.
! !

!SWTRootPanel class methodsFor: 'class initialization' stamp: 'dgd 9/3/2006 10:22'!
initialize
	
	| singleton |

	self jsInSmalltalk:[^ self].

	(self = SWTRootPanel) ifFalse:[ ^ self ].

	singleton := self new.

	self jsLiteral: 'SWT.RootPanel = singleton'.
! !

!SWTRootPanel class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 8/8/2006 16:29'!
jsPreSource
	^ '/* singleton holder */
SWT.RootPanel = null;
'! !

!SWTRootPanel methodsFor: 'dom counterpart' stamp: 'dgd 8/7/2006 21:32'!
dom
	^ self jsLiteral: 'document.body'! !

!SWTRootPanel methodsFor: 'accessing' stamp: 'dgd 8/7/2006 20:53'!
title: aString
	self jsLiteral: 'document.title = aString'.
! !

SWTWidget subclass: #SWTText
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTText subclass: #SWTEditInPlaceText
	instanceVariableNames: 'editing editingType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/29/2006 18:10'!
clearHandlers
	"private - removes all the events handlers."

	| myDom editors |

	myDom := self dom.

	myDom jsSet: #ondblclick to: nil.
	myDom jsSet: #onclick to: nil.
	myDom jsSet: #onmouseover to: nil.

	editors := self jsLiteral: 'myDom.getElementsByTagName("input")'.
	editors inlineDo:[:editor |
		editor jsSet: #onchange to: nil.
		editor jsSet: #onblur to: nil.
		editor jsSet: #onmouseout to: nil.
	].
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/11/2006 11:54'!
editingType: aString

	"private - change the receiver's editing type"

	editingType := aString.
	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 8/11/2006 11:54'!
editOnClick
	self editingType: 'click'! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 8/11/2006 11:54'!
editOnDblClick
	self editingType: 'dblclick'! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 8/11/2006 11:54'!
editOnMouseOver
	self editingType: 'mouseover'! !

!SWTEditInPlaceText methodsFor: 'initialization' stamp: 'dgd 8/11/2006 11:55'!
initialize
	super initialize.

	editing := false.
	editingType := 'click'.
! !

!SWTEditInPlaceText methodsFor: 'dom counterpart' stamp: 'dgd 8/11/2006 18:28'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	super initializeDom.

	self installHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/29/2006 18:34'!
installEditHandlers

	| handler editor |

	editor := self domFirstChild.

	handler := [:domEvent | self switchToNormalMode: false].

	self flag: #todo.	"register keypress, to capture the CR/TAB key to accept and Escape key to cancel"
	editor jsSet: #onblur to: handler.
	editor jsSet: #onchange to: handler.
	(editingType = 'mouseover') inlineIfTrue: [
		editor jsSet: #onmouseout to: handler.
	].
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/11/2006 13:20'!
installHandlers
	"private - install all the events handlers corresponding the the editing mode of the receiver"

	editing
		inlineIfTrue: [ self installEditHandlers ]
		ifFalse: [ self installNoEditHandlers ].
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/29/2006 18:23'!
installNoEditHandlers

	| myDom handler |

	myDom := self dom.
	handler := [:domEvent | self switchToEditMode ].

	(editingType = 'mouseover')
		inlineIfTrue: [ myDom jsSet: #onmouseover to: handler ].

	(editingType = 'click')
		inlineIfTrue: [ myDom jsSet: #onclick to: handler ].

	(editingType = 'dblclick')
		inlineIfTrue: [ myDom jsSet: #ondblclick to: handler ].
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:33'!
onClick: aBlock 
	self error: 'click is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:43'!
onDblClick: aBlock 
	self error: 'dblclick is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:43'!
onMouseOut: aBlock 
	self error: 'mouseout is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:43'!
onMouseOver: aBlock 
	self error: 'mouseover is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/11/2006 11:22'!
resetHandlers
	"private - reinstall the events handlers."

	self clearHandlers.
	self installHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/29/2006 19:18'!
switchToEditMode

	| editor |

	editing ifTrue:[^ self].
	editing := true.

	editor := self domCreateElement: 'input'.
	editor jsSet: #type to: 'text'.
	editor jsSet: #value to: contents.

	editor jsStyleSet: #width to: self width.
	editor jsStyleSet: #height to: self height.

	editor jsStyleSet: #borderWidth to: 2.
	editor jsStyleSet: #borderStyle to: 'solid'.
	backgroundColor isNil inlineIfFalse:[
		editor jsStyleSet: #backgroundColor to: backgroundColor asColorString.
		editor jsStyleSet: #borderColor to: backgroundColor muchDarker asColorString.
	].

	self
		domReplaceChild: self domFirstChild
		with: editor.

	"workaround for the firefox bug: https://bugzilla.mozilla.org/show_bug.cgi?id=236791"
	self jsLiteral: 'editor.setAttribute(''autocomplete'', ''off'')'.

	self jsLiteral: 'editor.focus()'.

	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/29/2006 18:36'!
switchToNormalMode: cancelBoolean

	| editor text |

	editing ifFalse:[^ self].
	editing := false.

	editor := self domFirstChild.
	cancelBoolean inlineIfFalse:[
		contents := editor jsGet: #value.
	].

	text := self domCreateTextNode: contents.
	self domReplaceChild: editor with: text.

	self resetHandlers.
! !

SWTText subclass: #SWTHeader
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTHeader class methodsFor: 'instance creation' stamp: 'dgd 8/10/2006 19:09'!
level: anInteger contents: aString
	^ (self contents: aString) initializeLevel: anInteger! !

!SWTHeader methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:41'!
createOuterDom

	| type |

	type := 'h' , level asString.

	^ self domCreateElement: type! !

!SWTHeader methodsFor: 'initialization' stamp: 'dgd 8/29/2006 16:47'!
initialize

	super initialize.

	level := 1.
! !

!SWTHeader methodsFor: 'initialization' stamp: 'dgd 8/10/2006 19:09'!
initializeLevel: anInteger
	level := anInteger.
! !

!SWTText class methodsFor: 'instance creation' stamp: 'dgd 8/10/2006 19:09'!
contents: aString
	^ self new initializeContents: aString! !

!SWTText methodsFor: 'accessing' stamp: 'dgd 9/5/2006 12:37'!
contents
	"Answer the receiver's contents"
	^ contents! !

!SWTText methodsFor: 'accessing' stamp: 'dgd 9/5/2006 12:37'!
contents: aString
	"Answer the receiver's contents"
	contents := aString.

	self dom jsSet: #innerHTML to: contents.! !

!SWTText methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:38'!
createDom

	| outer |

	outer := self createOuterDom.
"
	text := self domCreateTextNode: contents.
	self jsLiteral: 'outer.appendChild(text)'.

"
	outer jsSet: #innerHTML to: contents.

	^ outer.
! !

!SWTText methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 19:23'!
createOuterDom

	| div |

	div := self domCreateElement: 'div'.
	div jsStyleSet: #cssFloat to: 'left'.
	div jsStyleSet: #styleFloat to: 'left'.

	^ div
! !

!SWTText methodsFor: 'initialization' stamp: 'dgd 8/10/2006 19:08'!
initializeContents: aString
	contents := aString.! !

!SWTWidget class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 8/9/2006 13:54'!
jsClassesToInclude

	| result |
	
	result := Set new.

	result addAll: S2SPoint withAllSubclasses.
	result addAll: S2SColor withAllSubclasses.
	result addAll: SWTEvent withAllSubclasses.

	^ result
! !

!SWTWidget class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 8/8/2006 16:28'!
jsPreSource
	^ '/* SWT namespace */
var SWT = {};
'! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 8/11/2006 15:16'!
backgroundColor
	"answer the receiver's backgroundColor"

	^ backgroundColor! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:58'!
backgroundColor: aColorOrString
	"change the receiver's color"

	backgroundColor := aColorOrString.

	self dom
			jsStyleSet: #backgroundColor
			to: backgroundColor asColorString.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 20:01'!
bold
	"change the receiver's fontWeight to bold"

	self fontWeight: 'bold'! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:21'!
borderColor: aColorOrString
	"change the receiver's borderColor"

	self dom
			jsStyleSet: #borderColor
			to: aColorOrString asColorString.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:23'!
border: aNumberOrString
	"change the receiver's border"

	self dom
			jsStyleSet: #border
			to:aNumberOrString asString , 'px solid'
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:49'!
bounds
	^ self topLeft extent: self extent! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 8/11/2006 15:15'!
color
	"answer the receiver's color"

	^ color! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:58'!
color: aColorOrString
	"change the receiver's color"

	color := aColorOrString.

	self dom
			jsStyleSet: #color
			to: color asColorString.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/8/2006 16:54'!
createDom
	"create the receiver's dom counterpart"

	^ self subclassResponsibility.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/15/2006 13:24'!
cssClassName
	"answer the className to set on the receiver's dom counterpart"
	^ self className! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/11/2006 19:18'!
dom
	"answer the receiver's dom counterpart"

	dom isNil inlineIfTrue: [
		dom := self createDom.
		self initializeDom.
	].

	^ dom
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:39'!
domCreateElement: type
	^ self jsLiteral: 'document.createElement(type)'.! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:36'!
domCreateTextNode: aString
	^ self jsLiteral: 'document.createTextNode(aString)'! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:33'!
domFirstChild

	| myDom |

	myDom := self dom.
	
	^ self jsLiteral: 'myDom.firstChild'.
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:36'!
domReplaceChild: currentDom with: newDom

	| myDom |

	myDom := self dom.

	self jsLiteral: 'myDom.replaceChild(newDom, currentDom)'.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 8/29/2006 19:24'!
enable: aBoolean
	"change the receiver's enable status"

	self dom
			jsSet: #disable
			to: aBoolean not.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:41'!
extent
	^ self width @ self height.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 19:58'!
fontSize: aNumberOrString
	"change the receiver's fontSize"

	self dom
			jsStyleSet: #fontSize
			to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 19:58'!
fontStyle: aNumberOrString
	"change the receiver's fontStyle"

	self dom
			jsStyleSet: #fontStyle
			to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 19:59'!
fontWeight: aNumberOrString
	"change the receiver's fontWeight"

	self dom
			jsStyleSet: #fontWeight
			to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/29/2006 19:06'!
height
	^ self dom jsGet: #offsetHeight! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:59'!
height: aNumberOrString

	height := aNumberOrString.

	self dom
			jsStyleSet: #height
			to: height.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 19:03'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	self dom jsSet: #className to: self cssClassName.! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 20:01'!
italic
	"change the receiver's fontWeight to italic"

	self fontStyle: 'italic'! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:23'!
left
	| result obj |

	result := 0.
	obj := self dom.

	self jsLiteral: '
	if (obj.offsetParent) {
		while (obj.offsetParent) {
			result += obj.offsetLeft;
			obj = obj.offsetParent;
		}
	}
	else if (obj.x) {
		result = obj.x;
	}'.

	^ result
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/6/2006 19:55'!
model
	"answer the receiver's model"

	^ model! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/6/2006 19:55'!
model: anObject
	"change the receiver's model"

	model := anObject.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 19:04'!
onClick: aBlock 
	"registers a block, to evaluate, when onClick event occurs"

	"is very first handler?"
	onClick isNil ifTrue: [
		| handler |

		onClick := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |
					event := SWTClickEvent source: self domEvent: domEvent.
					onClick do: [:each | each value: event]
				].

		self dom jsSet: #onclick to: handler.
	].

	onClick add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 19:04'!
onDblClick: aBlock 
	"registers a block, to evaluate, when onDblClick event occurs"

	"is very first handler?"
	onDblClick isNil ifTrue: [
		| handler |

		onDblClick := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |
					event := SWTDblClickEvent source: self domEvent: domEvent.
					onDblClick do: [:each | each value: event].
				].

		self dom jsSet: #ondblclick to: handler.
	].

	onDblClick add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 19:04'!
onMouseOut: aBlock 
	"registers a block, to evaluate, when onMouseOut event occurs"

	"is very first handler?"
	onMouseOut isNil ifTrue: [
		| handler |

		onMouseOut := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |
					event := SWTMouseOutEvent source: self domEvent: domEvent.
					onMouseOut do: [:each | each value: event]
				].

		self dom jsSet: #onmouseout to: handler.
	].

	onMouseOut add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 19:04'!
onMouseOver: aBlock 
	"registers a block, to evaluate, when onMouseOver event occurs"

	"is very first handler?"
	onMouseOver isNil ifTrue: [
		| handler |

		onMouseOver := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |
					event := SWTMouseOverEvent source: self domEvent: domEvent.
					onMouseOver do: [:each | each value: event]
				].

		self dom jsSet: #onmouseover to: handler.
	].

	onMouseOver add: aBlock.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 8/9/2006 13:20'!
parent
	"answer the receiver's parent"

	^ parent! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 8/10/2006 13:31'!
parent: aPanel
	"change the receiver's parent"

	(aPanel notNil and: [parent notNil])
		ifTrue:[^ self error: 'The widget already has a parent'].

	parent := aPanel.
! !

!SWTWidget methodsFor: 'printing' stamp: 'dgd 8/10/2006 13:12'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' bounds=('.
	aStream nextPutAll: self bounds asString.
	aStream nextPutAll: ')'.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 9/4/2006 13:48'!
resourcesDirectory
	^'resources/'! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:24'!
top
	| result obj |

	result := 0.
	obj := self dom.

	self jsLiteral: '
	if (obj.offsetParent) {
		while (obj.offsetParent) {
			result += obj.offsetTop;
			obj = obj.offsetParent;
		}
	}
	else if (obj.y) {
		result = obj.y;
	}'.

	^ result
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:07'!
topLeft
	^ self top @ self left! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 8/29/2006 18:14'!
unload

	| myDom |

	myDom := self dom.

	myDom jsSet: #onclick to: nil.
	myDom jsSet: #ondblclick to: nil.
	myDom jsSet: #onmouseover to: nil.
	myDom jsSet: #onmouseout to: nil.

	parent isNil ifFalse:[
		parent removeWidget: self.
	].
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/29/2006 19:07'!
width
	^ self dom jsGet: #offsetWidth.! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:59'!
width: aNumberOrString

	width := aNumberOrString.

	self dom
		jsStyleSet: #width
		to: width.
! !

AComet subclass: #SWTApplicationRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTApplicationRunner class methodsFor: 'running' stamp: 'dgd 9/4/2006 13:42'!
assembleService: assembly


	assembly alias: '/JavascriptSource' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processJavascriptSourceRequest:
									argument: nil).
	].

	assembly alias: '/resources' to: [
		assembly documentRoot: (FileDirectory default fullNameFor: 'resources').
		assembly directoryIndex: 'index.html'.
		assembly serveFiles.
	].

	assembly addPlug: (MessageSend
								receiver: self instance
								selector: #process:
								argument: nil).
! !

!SWTApplicationRunner class methodsFor: 'running' stamp: 'dgd 8/31/2006 20:50'!
serviceName
	"Answer the receiver's intented service name"

	^ 'SWT - Squeak Widget Toolkit'! !

!SWTApplicationRunner class methodsFor: 'running' stamp: 'dgd 8/31/2006 20:50'!
servicePort
	"Answer the receiver's intented service port"

	^ 2222! !

!SWTApplicationRunner methodsFor: 'private - processing' stamp: 'dgd 9/5/2006 20:09'!
applicationsListHtml

	| response |

	response := String new writeStream.

	response nextPutAll: '<html>'.
	response nextPutAll: '<head>'.
	response nextPutAll: '<title>'.
	response nextPutAll: 'SWT Application Runner'.
	response nextPutAll: '</title>'.
	response nextPutAll: '</head>'.
	response nextPutAll: '<body>'.

	response nextPutAll: '<h3>Select the application to run</h3>'.
	response nextPutAll: '<ul>'.
	(SWTServerApplication allSubclasses asSortedCollection: [:x :y | x clientSideApplicationClass applicationName <= y clientSideApplicationClass applicationName])
		do:[:each |
			response nextPutAll: '<li>'.
			response nextPutAll: '<a href="' , each name , '">'.
			response nextPutAll: each clientSideApplicationClass applicationName.
			response nextPutAll: '</a>'.
		].
	response nextPutAll: '</ul>'.

	response nextPutAll: '</body>'.
	response nextPutAll: '</html>'.

	^ response contents.
! !

!SWTApplicationRunner methodsFor: 'private' stamp: 'dgd 9/3/2006 18:01'!
cometSocketClass

	^ SWTCometSocket! !

!SWTApplicationRunner methodsFor: 'private' stamp: 'dgd 9/3/2006 18:40'!
initCometSocket: aCometSocket 
	^ self script: ('
log = top.log;
id = top.id;

top.connect({1});
' format: { aCometSocket listenerId })! !

!SWTApplicationRunner methodsFor: 'rpc' stamp: 'dgd 9/5/2006 21:39'!
jsonReceiverFor: aDictionary request: aRequest

	| listId socket |

	listId := aDictionary
						at: 'connection_id'
						ifAbsent: [ ^ self error: 'connection_id is missing' ].

	socket := self
					listenerId: listId
					ifAbsent: [ ^ self error: 'invalid connection_id' ].

	^ socket serverApplication! !

!SWTApplicationRunner methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 21:36'!
justConnected: aCometSocket request: aRequest

	sockets
		select: [:each | each isKindOf: SWTCometSocket]
		thenDo: [:each | each justConnected: aCometSocket request: aRequest ].
! !

!SWTApplicationRunner methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 21:13'!
justDisconnected: aCometSocket

	sockets
		select: [:each | each isKindOf: SWTCometSocket]
		thenDo: [:each | each justDisconnected: aCometSocket ].
! !

!SWTApplicationRunner methodsFor: 'private - processing' stamp: 'dgd 8/31/2006 21:04'!
notFoundResponse

	^ HttpResponse 
				status: #notFound 
				contents: 'The object you requested was not found on this server.'
! !

!SWTApplicationRunner methodsFor: 'processing' stamp: 'dgd 9/1/2006 20:04'!
processJavascriptSourceRequest: aRequest 

	| pair applicationClassName sourceName response klass |

	pair := self sourceNameFrom: aRequest.

	applicationClassName := pair first: (pair indexOf: $/) - 1.
	sourceName := pair allButFirst: (pair indexOf: $/).

	klass := Smalltalk
						at: applicationClassName asSymbol
						ifAbsent:[ ^ self notFoundResponse ].

	(klass isValidClassName: sourceName) ifFalse:[
		^ self notFoundResponse
	].

	response := (klass updateLoadProgressIndicator: sourceName) , (klass sourceForClass: sourceName).

	^ HttpResponse
				fromString: response
				contentType: 'text/javascript'
! !

!SWTApplicationRunner methodsFor: 'processing' stamp: 'dgd 9/3/2006 13:03'!
process: aRequest 

	| url className klass |

	url := aRequest url.

	(url = '/')
		ifTrue:[ ^ self applicationsListHtml asHttpResponseTo: aRequest ].

	className := url allButFirst.
	
	klass := Smalltalk
						at: className asSymbol
						ifAbsent:[ ^ self notFoundResponse ].

	(klass inheritsFrom: SWTServerApplication)
		ifFalse:[ ^ self notFoundResponse ].

	^ klass htmlSource asHttpResponseTo: aRequest
! !

!SWTApplicationRunner methodsFor: 'private - processing' stamp: 'dgd 9/1/2006 19:47'!
sourceNameFrom: aRequest 

	| sourceName |

	sourceName := aRequest fields at: 'source' ifAbsent:[
		| path |
		path := ModCore path.
		(path beginsWith: '/')
			ifTrue:[path := path allButFirst].
		path
	].

	(sourceName endsWith:'.js')
		ifTrue:[sourceName := sourceName allButLast: 3].

	^ sourceName
! !

Object subclass: #SWTClientApplicationProxy
	instanceVariableNames: 'for multicast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTClientApplicationProxy class methodsFor: 'instance creation' stamp: 'dgd 9/5/2006 19:52'!
for: aClientApplicationClass multicast: aBoolean
	^ self new initializeFor: aClientApplicationClass multicast: aBoolean! !

!SWTClientApplicationProxy methodsFor: 'error handling' stamp: 'dgd 9/5/2006 19:56'!
doesNotUnderstand: aMessage

	for isNil ifFalse:[
		(for class clientSideApplicationClass canUnderstand: aMessage selector) ifTrue:[
			multicast
				ifTrue: [ for multicastClientSideMessageSend: aMessage ]
				ifFalse: [ for pushClientSideMessageSend: aMessage ].

			^ self
		].
	].

	^ super doesNotUnderstand: aMessage.
! !

!SWTClientApplicationProxy methodsFor: 'initialization' stamp: 'dgd 9/5/2006 19:51'!
initialize
	multicast := false.! !

!SWTClientApplicationProxy methodsFor: 'initialization' stamp: 'dgd 9/5/2006 19:51'!
initializeFor: aClientApplicationClass multicast: aBoolean
	for := aClientApplicationClass.
	multicast := aBoolean.
! !

Object subclass: #SWTServerApplication
	instanceVariableNames: 'socket clientSide clientSideMulticast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

SWTServerApplication subclass: #SWTExampleServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTExampleServerApplication methodsFor: 'tests' stamp: 'dgd 9/3/2006 13:11'!
bar: anObject
	Transcript show: 'bar: ' , anObject asString; cr.! !

!SWTExampleServerApplication methodsFor: 'tests' stamp: 'dgd 9/3/2006 16:47'!
foo
	Transcript show: 'foo!!'; cr.! !

!SWTExampleServerApplication methodsFor: 'tests' stamp: 'dgd 9/4/2006 11:33'!
ping
	Transcript show: 'ping!!'; cr.
	self clientSide pong.! !

SWTServerApplication subclass: #SWTPingPongServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTPingPongServerApplication methodsFor: 'ping/pong' stamp: 'dgd 9/5/2006 20:07'!
ping

	Transcript show: 'ping!!'; cr.

	self clientSide pong.
! !

!SWTServerApplication class methodsFor: 'configuration' stamp: 'dgd 9/1/2006 19:06'!
clientSideApplicationClass

	"Answer the receiver's pair class"

	| csClassName |

	csClassName := self name copyReplaceAll: 'Server' with: 'Client'.

	^ Smalltalk
			at: csClassName asSymbol
			ifAbsent:[self subclassResponsibility].
! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 9/3/2006 16:52'!
htmlSource
	^ self clientSideApplicationClass htmlSource: self serverApplicationProxySource , self scriptLibrary , self scriptLibraryJSON! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 9/5/2006 21:42'!
scriptLibrary
	^ '
<script type="text/javascript">

var ConnectionId = 0;
var ReconnectionId = 0;
var InvocationsInProcess = 0;
var InvokeId = 0;

function id(theId) {
	return document.getElementById(theId);
}

function log(msg) {
	// Try using Firebug
	if ((typeof console !!= "undefined") && (typeof console.debug !!= "undefined")) {
		console.log(msg);
	}

	var logDiv = id("log");
	if (!!logDiv) {
		return;
	}

	if (logDiv.style.visibility == "hidden") {
		return;
	}

	var message = msg;
	if (!!message) {
		message = "null";
	}

	logDiv.getElementsByTagName("div")[0].innerHTML += message.toString() + "<br/>";

     logDiv.scrollTop = logDiv.scrollHeight;
}

function logError(msg) {
	log ( "<font color=red><b>ERROR:</b> " + msg.toString() + "</font>");
}

function logWarning(msg) {
	log ( "<font color=blue>" + msg.toString() + "</font>");
}

function status(msg) {
	var logStatus = id("status");
	if (logStatus) {
		logStatus.getElementsByTagName("span")[0].innerHTML = msg;
	}
}

function toggleLog() {
	var logDiv = id("log");
	if (!!logDiv) {
		return;
	}
	if (logDiv.style.visibility == "hidden") {
		logDiv.style.visibility = "visible";
	}
	else {
		logDiv.style.visibility = "hidden";
	}
}

function connectedMessage() {
	return "<font color=green>CONNECTED</font>";
}

function connect(connectionId) {
	log ( "<b>CONNECTED: </b> ConnectionId=" + connectionId.toString() );
	ConnectionId = connectionId;

	window.defaultStatus = "Connected";
	status(connectedMessage());

	if (justConnected) {
		justConnected();
	}
}

function disconnectedMessage() {
	return "<font color=red size=+1>* DISCONNECTED *</font><br><br>Press the button to reconnect: <input type=\"button\" value=\"RECONNECT\" onClick=''reconnect()''>";
}

function disconnect() {
	logError ( "DISCONNECTED!!" );
	ConnectionId = 0;

	window.defaultStatus = "* DISCONNECTED *";
	status(disconnectedMessage());

	if (justDisconnected) {
		justDisconnected();
	}
}

function isConnected() {
	return ConnectionId !!= 0;
}

function createXmlHttp(widget) {
	var xmlhttp = false;

	/*@cc_on @*/
	/*@if (@_jscript_version >= 5)
	// JScript gives us Conditional compilation, we can cope with old IE versions.
	// and security blocked creation of the objects.
	try {
		xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
		try {
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (E) {
			xmlhttp = false;
		}
	}
	@end @*/
      
	if (!!xmlhttp && typeof XMLHttpRequest!!="undefined") {
		try {
			xmlhttp = new XMLHttpRequest();
		} catch (e) {
			xmlhttp = false;
		}
	}
      
	if (!!xmlhttp && window.createRequest) {
 		try {
			xmlhttp = window.createRequest();
		} catch (e) {
			xmlhttp = false;
		}
	}

	return xmlhttp;
}

function plainReconnect() {
	var iframe = id("CometIFrame");
	if (!!iframe) {
		logError ( "The IFrame with id=CometIFrame is not present" );
		return;
	}
	ReconnectionId = ReconnectionId + 1;
	logWarning ( "Trying to reconnect... " + ReconnectionId.toString() );
	iframe.src = "/SocketServer?application=' , self name , '&connection_id=1&reconnection_id=" + ReconnectionId.toString() + "&random=" + Math.random().toString();
}

function reconnect() {
	//if (!!isConnected()) {
	//	return;
	//}

	if (isConnected()) {
		disconnect();
	}

	plainReconnect();
	//setTimeout(plainReconnect, 2000);
}

function showStatusWheel() {
	InvocationsInProcess = InvocationsInProcess + 1;
	if (InvocationsInProcess > 0) {
		var logStatus = id("status");
		if (logStatus) {
			var img = logStatus.getElementsByTagName("img")[0];
			if (img.style.visibility !!= "visible") {
				img.style.visibility = "visible";
			}
		}		
	}
}

function hideStatusWheel() {
	InvocationsInProcess = InvocationsInProcess - 1;
	if (InvocationsInProcess <= 0) {
		var logStatus = id("status");
		if (logStatus) {
			logStatus.getElementsByTagName("img")[0].style.visibility = "hidden";
		}
	}
}

function invokeJsonRPCMethod(method, params, async, loged) {
	if (typeof params == "undefined") {
		params = null;
	}

	if (typeof loged == "undefined") {
		loged = true;
	}

	if (!!isConnected()) {
		if (loged) {
			logError( "can''t invoke methods while disconnected" );
		}
		return;
	}

	showStatusWheel();

	InvokeId = InvokeId + 1;

	var requestObject = Object();
	requestObject["id"] = InvokeId;
	requestObject["method"] = method;
	requestObject["params"] = params;
	requestObject["connection_id"] = ConnectionId;

	if (loged) {
		log( "<b>Request:</b>" + requestObject.toJSONString() );
	}

	var xmlhttp = createXmlHttp();
	if (!!xmlhttp) {
		hideStatusWheel();
		return;
	}

	if (typeof async == "undefined") {
		async = true;
	}

	xmlhttp.open("POST", "/SocketServer?random=" + Math.random().toString(), async);
	if (async) {
		xmlhttp.onreadystatechange = function() {
				if (xmlhttp.readyState == 4) {
					var response = xmlhttp.responseText.parseJSON();
					if (loged) {
						log( "<b>Response:</b>" + response.toJSONString() );
					}

					hideStatusWheel();
				}
			}
		xmlhttp.send( requestObject.toJSONString() );

		return true;
	}
	else {
		xmlhttp.send( requestObject.toJSONString() );

		var response = xmlhttp.responseText.parseJSON();
		if (loged) {
			log( "<b>Response:</b>" + response.toJSONString() );
		}

		hideStatusWheel();

		return response["result"];
	}
}


/* hook functions */
function justConnected() {
}

function justDisconnected() {
}

</script>
'! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 9/3/2006 16:52'!
scriptLibraryJSON
	^'
<script type="text/javascript">
<!!--
/*
    json.js
    2006-04-28

    This file adds these methods to JavaScript:

        object.toJSONString()

            This method produces a JSON text from an object. The
            object must not contain any cyclical references.

        array.toJSONString()

            This method produces a JSON text from an array. The
            array must not contain any cyclical references.

        string.parseJSON()

            This method parses a JSON text to produce an object or
            array. It will return false if there is an error.
*/
(function () {
    var m = {
            "\b": "\\b",
            "\t": "\\t",
            "\n": "\\n",
            "\f": "\\f",
            "\r": "\\r",
            ''"'' : ''\\"'',
            "\\": "\\\\"
        },
        s = {
            array: function (x) {
                var a = ["["], b, f, i, l = x.length, v;
                for (i = 0; i < l; i += 1) {
                    v = x[i];
                    f = s[typeof v];
                    if (f) {
                        v = f(v);
                        if (typeof v == "string") {
                            if (b) {
                                a[a.length] = ",";
                            }
                            a[a.length] = v;
                            b = true;
                        }
                    }
                }
                a[a.length] = "]";
                return a.join("");
            },
            "boolean": function (x) {
                return String(x);
            },
            "null": function (x) {
                return "null";
            },
            number: function (x) {
                return isFinite(x) ? String(x) : "null";
            },
            object: function (x) {
                if (x) {
                    if (x instanceof Array) {
                        return s.array(x);
                    }
                    var a = ["{"], b, f, i, v;
                    for (i in x) {
                        v = x[i];
                        f = s[typeof v];
                        if (f) {
                            v = f(v);
                            if (typeof v == "string") {
                                if (b) {
                                    a[a.length] = ",";
                                }
                                a.push(s.string(i), ":", v);
                                b = true;
                            }
                        }
                    }
                    a[a.length] = "}";
                    return a.join("");
                }
                return "null";
            },
            string: function (x) {
                if (/["\\\x00-\x1f]/.test(x)) {
                    x = x.replace(/([\x00-\x1f\\"])/g, function(a, b) {
                        var c = m[b];
                        if (c) {
                            return c;
                        }
                        c = b.charCodeAt();
                        return "\\u00" +
                            Math.floor(c / 16).toString(16) +
                            (c % 16).toString(16);
                    });
                }
                return ''"'' + x + ''"'';
            }
        };

    Object.prototype.toJSONString = function () {
        return s.object(this);
    };

    Array.prototype.toJSONString = function () {
        return s.array(this);
    };
})();

String.prototype.parseJSON = function () {
    try {
        return !!(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
                this.replace(/"(\\.|[^"\\])*"/g, ""))) &&
            eval("(" + this + ")");
    } catch (e) {
        return false;
    }
};
-->
</script>
'! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 9/3/2006 13:32'!
serverApplicationProxySource

	| result translator |

	result := String new writeStream.

	result nextPutAll: '<script type="text/javascript">'; cr.
	result nextPutAll: '/* proxy methods generated from ' , self name , '*/'; cr.

	translator := S2STranslator new.

	self selectors do:[:selector |
		| jsMethodName numArgs args |

		jsMethodName := translator convertSelectorToJsMethodName: selector.

		numArgs := (self compiledMethodAt: selector) numArgs.

		result nextPutAll: ('ST.SWTServerApplicationProxy.prototype.{1} = function(' format: {jsMethodName}).

		args := String streamContents:[:stream |
			(1 to: numArgs)
				do:[:index | stream nextPutAll: ('arg{1}' format: {index})]
				separatedBy:[ stream nextPutAll: ', '].
		].

		result nextPutAll: args.

		result nextPutAll: ') {'; cr.
		result nextPutAll: ('	return invokeJsonRPCMethod("{1}", [{2}]);' format: {selector. args}); cr.
		result nextPutAll: '};'; cr.
	].

	result nextPutAll: '</script>'; cr.

	^ result contents.
! !

!SWTServerApplication class methodsFor: 'instance creation' stamp: 'dgd 9/3/2006 20:46'!
socket: aSWTCometSocket 
	^ self new initializeSocket: aSWTCometSocket ! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 8/31/2006 20:16'!
clientSide
	"Answer the receiver's client side counterpart"

	^ clientSide
! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 19:53'!
clientSideMulticast
	"Answer the receiver's client side counterpart"

	^ clientSideMulticast
! !

!SWTServerApplication methodsFor: 'initialization' stamp: 'dgd 9/5/2006 19:54'!
initialize
	"Initialize the receiver"

	super initialize.

	clientSide := SWTClientApplicationProxy for: self multicast: false.
	clientSideMulticast := SWTClientApplicationProxy for: self multicast: true.
! !

!SWTServerApplication methodsFor: 'initialization' stamp: 'dgd 9/5/2006 22:52'!
initializeSocket: aSWTCometSocket 
	socket := aSWTCometSocket.
! !

!SWTServerApplication methodsFor: 'pushing' stamp: 'dgd 9/5/2006 19:47'!
jsMethodInvocationFrom: aMessage 

	| jsMethodName params translator |

	params := String new writeStream.

	aMessage arguments 
		do: [:each | params nextPutAll: (Json render: each) "convertToUTF8"]
		separatedBy: [params nextPutAll: ', '].

	translator := S2STranslator new.

	jsMethodName := translator convertSelectorToJsMethodName: aMessage selector.

	^ 'top.application.{1}({2})' format: { jsMethodName. (params contents) }.
! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:53'!
justConnected: aSWTCometSocket.
	! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:58'!
justDisconnected: aSWTCometSocket ! !

!SWTServerApplication methodsFor: 'pushing' stamp: 'dgd 9/5/2006 22:18'!
multicastClientSideMessageSend: aMessage 

	| script |

	script := self jsMethodInvocationFrom: aMessage.

	self runner
		pushScript: [:soc | script]
		select:[:soc |
			(soc isKindOf: SWTCometSocket)
				and:[soc hasServerApplication]
				and:[soc serverApplication class == self class]
		].
! !

!SWTServerApplication methodsFor: 'pushing' stamp: 'dgd 9/5/2006 22:19'!
pushClientSideMessageSend: aMessage 

	| script |

	script := self jsMethodInvocationFrom: aMessage.

	self socket pushScript: [:soc | script].
! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 22:18'!
runner
	"Answer the receiver's runner"
	^ socket runner! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 22:19'!
socket
	"Answer the receiver's socket"
	^ socket! !

SWTServerApplication subclass: #SWTSocialShoppingServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-View'!

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 20:44'!
buyProductId: anInteger

	| product |

	product := self system productById: anInteger.

	self buyProduct: product! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 20:08'!
buyProduct: aSWTSocialShoppingProduct 

	self system inventory removeProduct: aSWTSocialShoppingProduct.
	self system cart addProduct: aSWTSocialShoppingProduct.

	self sendInventory: true.
	self sendCart: true.
! !

!SWTSocialShoppingServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/6/2006 20:08'!
justConnected: aSWTCometSocket

	super justConnected: aSWTCometSocket.

	self sendUsersList.
	self sendInventory: false.
	self sendCart: false.
! !

!SWTSocialShoppingServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:56'!
justDisconnected: aSWTCometSocket 

	super justDisconnected: aSWTCometSocket.

	self sendUsersList.! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 20:42'!
notBuyProductId: anInteger

	| product |

	product := self system productById: anInteger.

	self notBuyProduct: product! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 20:29'!
notBuyProduct: aSWTSocialShoppingProduct 

	self system cart removeProduct: aSWTSocialShoppingProduct.
	self system inventory addProduct: aSWTSocialShoppingProduct.

	self sendInventory: true.
	self sendCart: true.
! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - chat' stamp: 'dgd 9/6/2006 13:08'!
receiveChatMessage: aString from: userNameString
	"Transcript show: userNameString , ': ' , aString asString; cr."

	self clientSideMulticast receiveChatMessage: aString from: userNameString.
! !

!SWTSocialShoppingServerApplication methodsFor: 'sending' stamp: 'dgd 9/6/2006 20:14'!
sendCart: multicastBoolean

	| receiver |

	receiver := multicastBoolean
							ifTrue: [self clientSideMulticast]
							ifFalse: [self clientSide].

	receiver receiveCart: self system cart asJsonSerializable.
! !

!SWTSocialShoppingServerApplication methodsFor: 'sending' stamp: 'dgd 9/6/2006 20:07'!
sendInventory: multicastBoolean

	| receiver |

	receiver := multicastBoolean
							ifTrue: [self clientSideMulticast]
							ifFalse: [self clientSide].

	receiver receiveInventory: self system inventory asJsonSerializable.
! !

!SWTSocialShoppingServerApplication methodsFor: 'sending' stamp: 'dgd 9/5/2006 22:58'!
sendUsersList

	| users |

	users := (self runner sockets collect: [:each | '#' , each listenerId asString]) asSortedCollection.

	self clientSide receiveUsersList: users.
! !

!SWTSocialShoppingServerApplication methodsFor: 'accessing' stamp: 'dgd 9/6/2006 14:09'!
system
	^ SWTSocialShoppingSystem instance! !

Object subclass: #SWTSocialShoppingProduct
	instanceVariableNames: 'id title description price image'
	classVariableNames: 'ID'
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

!SWTSocialShoppingProduct class methodsFor: 'instance creation' stamp: 'dgd 9/6/2006 19:10'!
title: titleString description: descriptionString price: aNumber image: imageSrcString
	^ self new initializeTitle: titleString description: descriptionString price: aNumber image: imageSrcString! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:50'!
description
	^ description! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 19:51'!
id
	^ id! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 19:11'!
image
	^ image! !

!SWTSocialShoppingProduct methodsFor: 'initialization' stamp: 'dgd 9/6/2006 19:50'!
initialize

	ID isNil ifTrue:[ID := 0].

	ID := ID + 1.
	id := ID.! !

!SWTSocialShoppingProduct methodsFor: 'initialization' stamp: 'dgd 9/6/2006 19:10'!
initializeTitle: titleString description: descriptionString price: aNumber image: imageSrcString

	title := titleString.
	description := descriptionString.
	price := aNumber.
	image := imageSrcString.
! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:50'!
price
	^ price! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:50'!
title
	^ title! !

Object subclass: #SWTSocialShoppingProductHolder
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

SWTSocialShoppingProductHolder subclass: #SWTSocialShoppingCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

SWTSocialShoppingProductHolder subclass: #SWTSocialShoppingInventory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

!SWTSocialShoppingInventory methodsFor: 'initialization' stamp: 'dgd 9/6/2006 13:59'!
initialize
	super initialize.

	self initializeExampleProducts.! !

!SWTSocialShoppingInventory methodsFor: 'initialization' stamp: 'dgd 9/6/2006 19:33'!
initializeExampleProducts

	self
		addProduct: (SWTSocialShoppingProduct
										title: 'Jamn Ibrico'
										description: ' El jamn ibrico de bellota es un producto elaborado artesanalmente, dndosele a la pata un corte tpicamente serrano. Su exquisitez se debe a la alimentacin del cerdo, a base de hierbas y bellotas al aire libre en la sierra.'
										price: 70
										image: 'jamoniberico.png')
		count: 10.

	self
		addProduct: (SWTSocialShoppingProduct
										title: 'Torta del Casar'
										description:
										'Elaborada por los mtodos tradicionales heredados de padres a hijos durante generaciones, para no perder su autenticidad.'
										price: 25
										image: 'tortadelcasar.png')
		count: 15.


	self
		addProduct: (SWTSocialShoppingProduct
										title: 'Chorizo Ibrico'
										description:
										'Elaborado con magro de cerdo ibrico de bellota, condimentado con sal y pimentn natural. Tras macerar durante 24 horas, se cura mediante secado natural durante al menos 3 meses lo que afina su caracterstico sabor y aroma.'
										price: 10
										image: 'chorizoiberico.png')
		count: 15.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:58'!
addProduct: aProduct
	items add: aProduct.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 14:00'!
addProduct: aProduct count: anInteger
	
	anInteger timesRepeat: [self addProduct: aProduct].
! !

!SWTSocialShoppingProductHolder methodsFor: 'serialization' stamp: 'dgd 9/6/2006 20:06'!
asJsonSerializable
	"Answer a representation of the receiver that can be serialized using JSON format"

	| result |

	result := OrderedCollection new.

	(self countsAndProducts asSortedCollection:[:x :y | x value title <= y value title]) do:[:ass |
		| count product dict |

		count := ass key.
		product := ass value.
"
		dict := Dictionary new.
		dict at: 'title' put: product title.
		dict at: 'description' put: product description.
		dict at: 'price' put: product price.
		dict at: 'count' put: count.

		result add: dict.
"		result add: { product title. product description. product price. count. product image. product id}
	].

	^ result.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:59'!
countsAndProducts
	^ items sortedCounts! !

!SWTSocialShoppingProductHolder methodsFor: 'initialization' stamp: 'dgd 9/6/2006 13:59'!
initialize
	super initialize.

	items := Bag new.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:00'!
productById: anInteger 
	^ items detect:[:each | each id = anInteger]! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:43'!
productById: anInteger ifAbsent: aBlock
	^ items detect:[:each | each id = anInteger] ifNone: aBlock! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:04'!
removeProduct: aProduct 
	items remove: aProduct! !

Object subclass: #SWTSocialShoppingSystem
	instanceVariableNames: 'cart inventory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

SWTSocialShoppingSystem class
	instanceVariableNames: 'instance'!

!SWTSocialShoppingSystem class methodsFor: 'singleton accessing' stamp: 'dgd 9/6/2006 13:55'!
clearInstance
	"Clear the receiver (singleton) instance"

	instance := nil
! !

!SWTSocialShoppingSystem class methodsFor: 'singleton accessing' stamp: 'dgd 9/6/2006 13:43'!
initializeInstance
	instance := super new.! !

!SWTSocialShoppingSystem class methodsFor: 'singleton accessing' stamp: 'dgd 9/6/2006 13:43'!
instance

	instance isNil
		ifTrue:[self initializeInstance].

	^ instance.
! !

!SWTSocialShoppingSystem class methodsFor: 'instance creation' stamp: 'dgd 9/6/2006 13:44'!
new
	^ self error: 'Singleton class, use #instance to get the instance'.
! !

!SWTSocialShoppingSystem methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:46'!
cart
	^ cart! !

!SWTSocialShoppingSystem methodsFor: 'initialization' stamp: 'dgd 9/6/2006 13:46'!
initialize

	super initialize.

	cart := SWTSocialShoppingCart new.
	inventory := SWTSocialShoppingInventory new.
! !

!SWTSocialShoppingSystem methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:47'!
inventory
	^ inventory! !

!SWTSocialShoppingSystem methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:44'!
productById: aSmallInteger 
	^ inventory
			productById: aSmallInteger
			ifAbsent:[ cart productById: aSmallInteger ]! !

ACometSocket subclass: #SWTCometSocket
	instanceVariableNames: 'serverApplication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 9/5/2006 21:39'!
hasServerApplication
	^serverApplication notNil! !

!SWTCometSocket methodsFor: 'initialization' stamp: 'dgd 9/3/2006 18:01'!
initialize
	super initialize.
	! !

!SWTCometSocket methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:57'!
justConnected: aSWTCometSocket request: aRequest
	

	aSWTCometSocket == self ifTrue:[
		| serverAppName klass |

		serverAppName := aRequest getFields
												at: 'application'
												ifAbsent:[ ^ self error: 'application name is missing' ].
		klass := Smalltalk
							at: serverAppName asSymbol
							ifAbsent:[ ^ self error: 'invalid application class' ].

		(klass inheritsFrom: SWTServerApplication)
			ifFalse:[ ^ self error: 'invalid application class (not proper class)' ].

		serverApplication := klass socket: self.
	].

	serverApplication	isNil ifFalse:[
		serverApplication justConnected: aSWTCometSocket.
	]
! !

!SWTCometSocket methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:56'!
justDisconnected: aSWTCometSocket 

	serverApplication isNil ifTrue: [^ self].

	serverApplication justDisconnected: aSWTCometSocket! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 9/5/2006 21:39'!
serverApplication
	^ serverApplication! !
SWTRootPanel initialize!
